CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    
    playRate = 30 'Hz
                                     
VAR
  long bkFreq, bleepOn, frame

OBJ
  SID : "SIDCog"

PUB Main

  initSid

  repeat
    handleBackgroundNoise

    bleepOn := true

    ifnot frame&63
      playBeep(9000, 8)

    ifnot (frame+32)&63
      playExplosion(800)


PUB handleBackgroundNoise | i

  frame++
  waitcnt( cnt + (clkfreq/playRate) )

  if bleepOn == false
    return

  if (?bkFreq)&1
    return

  SID.setWaveform(2, (?bkFreq)&3)
  SID.setADSR(2, 0, 7, 0, 2)
  SID.setPWM(2, (?bkFreq)&4095)
  SID.noteOff(2)
  SID.noteOn(2, (?bkFreq&65535) | 1023 )

PUB playExplosion(freq)
  SID.setWaveform(0, 3)
  SID.setADSR(0, 0, 10, 0, 0)
  SID.noteOff(0)
  SID.noteOn(0, freq)

PUB playBeep(freq, time)
  SID.setWaveform(1, 2)
  SID.setADSR(1, 0, time, 0, 2)
  SID.setPWM(1, 2047)
  SID.noteOff(1)
  SID.noteOn(1, freq)

PUB enableBackgroundBleeps( bleepsOn )
  SID.setWaveform(0, 3)
  SID.noteOn(0, 12345)

PUB initSid
  SID.start                              'Start the emulated SID chip in one cog
                    'Lp,   Bp,   Hp
  SID.setFilterType(true, false, false)    'Enable lowpass filter

                    'Ch1, Ch2, Ch3
  SID.setFilterMask(true, false, false)    'Enable filter on the bass channel (channel1)

  SID.setCutoff(200)
  SID.setPWM(0,1928)                     'Set the pulse width on channel1 to 47:53

  SID.setWaveform(0,2)                   'Set waveform type on channel1 to Square wave

  SID.setADSR(0,2,5,9,6)                 'Set Envelope on channel1
  SID.setWaveform(1,3)                   'Set waveform type on channel2 to Noise (drum sound)
  SID.setADSR(1,0,8,4,7)                 'Set Envelope on channel2
  SID.setWaveform(2,1)                   'Set waveform type on channel2 to Saw wave
  SID.setADSR(2,7,4,8,9)                 'Set Envelope on channel3
  SID.setVolume(15)                      'Set volume to max

